multiplierParAddition(5, -3);

function multiplierParAddition(x: number, y: number): number {
    let val = 0;

    // Si y est négatif, on le rend positif et on inverse le signe de x
    if (y < 0) {
        y = -y;
        x = -x;
    }

    // Optimisation : toujours boucler sur le plus petit nombre
    if (y < x) {
        [x, y] = [y, x];
    }

    console.log(`Valeurs utilisées pour la boucle : x = ${x}, y = ${y}`);

    for (let i = 0; i < y; i++) {
        val += x;
    }
    return val;
}

// Tests avec les cas donnés
const testCases: [number, number][] = [
    [0, 0], [5, 3], [3, 5], [-5, -2], [-2, -5],
    [-74, 2], [-1, 75], [10, -25], [10, -3]
];

testCases.forEach(([x, y]) => {
    const result = multiplierParAddition(x, y);
    console.log(`multiplierParAddition(${x}, ${y}) = ${result}`);
});
